//
//  common_utils.c
//  bpic
//
//  Created by theBreadCompany on 04.03.23.
//

#include <common_utils.h>

void throw_err(const char* message, int error) {
    char *category = error ? "ERROR:" : "NOTE:";
    fprintf(stderr, "%s %s", category, message);
}

void debug(FILE *pipe, const char *message, ...) {
#if DEBUG || debug
    fprintf(pipe, "%s", message);
#endif
}

bpic_message bpic_error_input_file_null     = "Input file is null!";
bpic_message bpic_error_input_buffer_null   = "Input buffer is null!";
bpic_message bpic_error_input_buffer_small  = "Input buffer too small!";
bpic_message bpic_warn_encoding_invalid     = "Encoding is invalid, defaulting to bitwise (0)";
bpic_message bpic_warn_pxsize_null          = "Pixel size is null, defaulting to 2";

uint16_t fletcher16(const unsigned char *data, size_t size) {
    uint16_t sum1 = 0;
    uint16_t sum2 = 0;

    for (int index = 0; index < size; index++) {
       sum1 = (sum1 + data[index]) % 0xFF;
       sum2 = (sum2 + sum1) % 0xFF;
    }

    return (sum2 << 8) | sum1;
}
