//
//  encode.h
//  bpic
//
//  Created by theBreadCompany on 04.03.23.
//

#ifndef encode_h
#define encode_h

#include "common_utils.h"

/**
 encode memory
 
 @param data The memory buffer to encode
 @param info A bpic_info struct containing parameters like encoding and any calculated variables on return; NULL is valid.
 @returns A pointer to the encoded memory or a bpic\_message on if an error occured.
 */
encoded_data *bpic_encode_memory(image_data *data, bpic_info* info);

/**
 encode a file
 
 @param input A pointer to the file to encode; NULL is invalid
 @param info A bpic_info struct containing parameters like encoding and any calculated variables on return; NULL is valid.
 @returns A pointer to the encoded memory or a bpic\_message on if an error occured.
 */
encoded_data *bpic_encode_file(FILE *input, bpic_info* info);

#endif /* encode_h */
