//
//  main.m
//  bpicdecode
//
//  Created by theBreadCompany on 28.02.23.
//

#include <stdio.h>
#include <stdlib.h>
#include "bpic.h"


int main(int argc, const char * argv[]) {
    FILE *inputFile;
    FILE *outputFile;
    
    if(argc < 2) {
        fprintf(stderr, "Missing path to file!\n");
        return 1;
    }
    
    inputFile = fopen(argv[1], "rb");
    if(!inputFile) {
        fprintf(stderr, "Could not open file %s\n", argv[2]);
        return 1;
    }

    
    // input as memory
    encoded_data *input = malloc(sizeof(encoded_data));
    fseek(inputFile, 0, SEEK_END);
    input->size = ftell(inputFile);
    fseek(inputFile, 0, SEEK_SET);
    input->buffer = malloc(input->size);
    fread(input->buffer, sizeof(unsigned char), input->size, inputFile);
    
    
    clock_t start = clock();
    bool checksum_matching = false;
    //encoded_data *data = bpic_decode_file(inputFile);
    encoded_data *data = bpic_decode_memory(input, &checksum_matching);
    clock_t end = clock();
    
    free(input->buffer);
    free(input);
    fclose(inputFile);
    printf("Done in %f seconds.\n", (double)(end - start) / CLOCKS_PER_SEC);
    
    uint8_t len = strlen(argv[1]) + 5;
    char *oname = calloc(len, sizeof(const char));
    strcpy(oname, argv[1]);
    strcpy(oname + len - 5, ".png");
    outputFile = fopen(oname, "wb");
    
    int error = 0;
    if(fwrite(data->buffer, sizeof(unsigned char), data->size, outputFile) != data->size * sizeof(unsigned char)) {
        fprintf(stderr, "Failed writing output file!");
        error = 1;
    }
    
    fclose(outputFile);
    
    //free(inputFile);
    free(oname);
    free(data->buffer);
    free(data);
    //free(outputFile);
    inputFile = NULL;
    outputFile = NULL;
    
    return error;
}


